
DROP FUNCTION IF EXISTS LV_VERSION_COMPARE ;

delimiter ;;

CREATE FUNCTION LV_VERSION_COMPARE(ver_1 VARCHAR(50), ver_2 VARCHAR(50)) RETURNS INT
    DETERMINISTIC
    COMMENT 'Return 1, -1 OR 0 comparing VER_1 with VER_2'
BEGIN
    DECLARE v_ver1 VARCHAR(50);
    DECLARE v_ver2 VARCHAR(50);
    DECLARE v_ver1_tmp VARCHAR(11);
    DECLARE v_ver2_tmp VARCHAR(11);
	DECLARE loc1 int;
	DECLARE loc2 int;

    SET v_ver1 = ver_1;
    SET v_ver2 = ver_2;

	IF strcmp( v_ver1, v_ver2 ) = 0
	THEN
		return 0;
	END IF;
		
    WHILE True DO

		SET v_ver1_tmp = LPAD(SUBSTRING_INDEX(v_ver1, '.', 1), 10, '0');
		SET v_ver2_tmp = LPAD(SUBSTRING_INDEX(v_ver2, '.', 1), 10, '0');

		IF strcmp( v_ver1_tmp, v_ver2_tmp ) > 0
		THEN
			return 1;
		ELSEIF strcmp( v_ver1_tmp, v_ver2_tmp ) < 0
		THEN
			RETURN -1;
		ELSE
			SET loc1 = LOCATE('.', v_ver1);
			SET loc2 = LOCATE('.', v_ver2);
			IF loc1 = 0 AND loc2 <> 0 
			THEN
				RETURN -1;
			ELSEIF loc1 <> 0 AND loc2 = 0 
			THEN
				RETURN 1;
			ELSEIF loc1 = 0 AND loc2 = 0 
			THEN
				RETURN 0;
			END IF;
			SET v_ver1 = SUBSTRING(v_ver1,loc1+1);
			SET v_ver2 = SUBSTRING(v_ver2,loc2+1);
		END IF;

    END WHILE;

    RETURN 0;

END ;;
delimiter ;
